;	Chatroom 1.00 Copyright (C) 2007 Albu Cristian
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\wsock32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\wsock32.lib
	include	plprocs.h

.data?
	hInstance	dd	?
	bothnd		dd	?
	_GetAddr	dd	?
	RegisterHubBot	dd	?
	UnregisterHubBot dd	?
	GetMastersCount	dd	?
	GetMastersIds	dd	?
	GetLanguage	dd	?
	SendTo		dd	?
	NickFromId	dd	?
	languages	db	100 dup(?)
	datafile	db	8192 dup(?)
	bread		dd	?
	masters		dd	32768 dup(?)
	buftmp		db	32768 dup(?)

.code
pluginName	db	'Multi-language chatroom for users',0
fn01		db	'RegisterBot',0
fn02		db	'UnregisterBot',0
fn03		db	'GetMastersCount',0
fn04		db	'GetMastersIds',0
fn05		db	'SendTo',0
fn06		db	'NickFromId',0
fn07		db	'GetLanguage',0
botname		db	'$MyINFO $ALL Chatroom Chatroom 1.00 by Albu Cristian $ $Bot',1,'$$0$',0
lngerr		db	'This chatroom is only for users who set these languages: ',0

_tbl1	db	1,'language (restrict the chatroom only for users who set specified languages)',0
	db	115
	dd	offset languages
	dw	100
	db	-1
_tbl	dd	offset _tbl1
	dd	-1

pl_procs

DllEntry PROC dllInstance:DWORD,reason:DWORD,reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
		push	dllInstance
		pop	hInstance
	.elseif reason==DLL_PROCESS_DETACH
	.elseif reason==DLL_THREAD_ATTACH
	.else
	.endif
	xor	eax,eax
	inc	eax
	ret
DllEntry Endp

GetConfigurationStringsTable	PROC
	lea	eax,_tbl
	ret
GetConfigurationStringsTable	ENDP

InitPlugin	PROC	uses esi edi GetAddr:DWORD
	push	edi
	mov	languages,0
	call	getdatafile
	invoke	CreateFile,addr datafile,GENERIC_READ,0,0,OPEN_EXISTING,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		invoke	ReadFile,edi,addr languages,sizeof languages,addr bread,0
		call	CloseHandle
	.endif
	pop	edi
	mov	eax,GetAddr
	mov	_GetAddr,eax
	push	offset fn01
	call	_GetAddr
	mov	RegisterHubBot,eax
	push	offset fn02
	call	_GetAddr
	mov	UnregisterHubBot,eax
	push	offset fn03
	call	_GetAddr
	mov	GetMastersCount,eax
	push	offset fn04
	call	_GetAddr
	mov	GetMastersIds,eax
	push	offset fn05
	call	_GetAddr
	mov	SendTo,eax
	push	offset fn06
	call	_GetAddr
	mov	NickFromId,eax
	push	offset fn07
	call	_GetAddr
	mov	GetLanguage,eax
	push	offset onPM
	push	offset botname
	call	RegisterHubBot
	mov	bothnd,eax
	lea	eax,pluginName
	ret
InitPlugin	ENDP

UnloadPlugin	PROC uses esi
	push	bothnd
	call	UnregisterHubBot
	ret
UnloadPlugin	ENDP

SaveSettings	PROC
	invoke	SetFileAttributes,addr datafile,0
	invoke	DeleteFile,addr datafile
	invoke	CreateFile,addr datafile,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
	.if eax!=INVALID_HANDLE_VALUE
		push	eax
		mov	edi,eax
		invoke	WriteFile,edi,addr languages,sizeof languages,addr bread,0
		call	CloseHandle
	.endif
	ret
SaveSettings	ENDP

_about	db	'Albu Cristian, 2007',0
GetAboutText	PROC
	mov	eax,offset _about
	ret
GetAboutText	ENDP

onPM	PROC uses esi edi botID:DWORD,userID:DWORD,lpBuf:DWORD,szBuf:DWORD
	local	mstrs:DWORD,hMem:DWORD,lng:DWORD,lngres:DWORD
	call	GetMastersCount
	.if eax>32768
		mov	eax,32768
	.endif
	mov	mstrs,eax
	push	eax
	push	offset masters
	call	GetMastersIds
	mov	ecx,mstrs
	mov	eax,userID
	lea	esi,masters
	.while ecx
		.break .if eax==[esi]
		dec	ecx
		lea	esi,[esi+4]
	.endw
	.if ecx==0
		ret
	.endif
	lea	esi,languages
	.while byte ptr[esi]==32
		inc	esi
	.endw
	.if (byte ptr[esi]!=0)&&(word ptr[esi]!='.')
		mov	lngres,1
		lea	eax,lng
		push	eax
		push	userID
		call	GetLanguage
		mov	eax,lng
		or	ax,2020h
		xor	edx,edx
		.while byte ptr[esi]
			mov	dx,[esi]
			or	dx,2020h
			.break .if ax==dx
			.while (byte ptr[esi]!=0)&&(byte ptr[esi]!=32)
				inc	esi
			.endw
			.while byte ptr[esi]==32
				inc	esi
			.endw
		.endw
		.if ax!=dx
			invoke	GlobalAlloc,GPTR,32768
			mov	hMem,eax
			mov	edi,hMem
			mov	eax,':oT$'
			stosd
			mov	al,32
			stosb
			push	edi
			push	userID
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	eax,'orF '
			stosd
			mov	eax,' :m'
			stosd
			dec	edi
			push	edi
			push	bothnd
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	eax,'<$ '
			stosd
			dec	edi
			push	edi
			push	bothnd
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	ax,' >'
			stosw
			lea	edx,lngerr
			call	copyedx
			lea	edx,languages
			.while byte ptr[edx]==32
				inc	edx
			.endw
			.while byte ptr[edx]
				mov	ax,[edx]
				.if (al>='a')
					sub	al,32
				.endif
				.if ah>='a'
					sub	ah,32
				.endif
				.if (al>='A')&&(al<='Z')&&(ah>='A')&&(ah<='Z')
					stosw
				.endif
				.while (byte ptr[edx]!=0)&&(byte ptr[edx]!=32)
					inc	edx
				.endw
				.while byte ptr[edx]==32
					inc	edx
				.endw
			.endw
			mov	al,'|'
			stosb
			mov	ecx,edi
			sub	ecx,hMem
			push	ecx
			push	hMem
			push	userID
			call	SendTo
			invoke	GlobalFree,hMem
			ret
		.endif
	.else
		mov	lngres,0
	.endif
	invoke	GlobalAlloc,GPTR,32768
	mov	hMem,eax
	lea	esi,masters
	.while mstrs
		mov	edi,hMem
		mov	eax,':oT$'
		stosd
		mov	al,32
		stosb
		lodsd
		.if eax!=userID
			.if lngres
				push	esi
				lea	esi,languages
				.while byte ptr[esi]==32
					inc	esi
				.endw
				.if byte ptr[esi]
					push	eax
					lea	eax,lng
					push	eax
					push	userID
					call	GetLanguage
					mov	eax,lng
					or	ax,2020h
					xor	edx,edx
					.while byte ptr[esi]
						mov	dx,[esi]
						or	dx,2020h
						.break .if ax==dx
						.while (byte ptr[esi]!=0)&&(byte ptr[esi]!=32)
							inc	esi
						.endw
						.while byte ptr[esi]==32
							inc	esi
						.endw
					.endw
					.if ax!=dx
						pop	eax
						pop	esi
						jmp	_nlang
					.endif
					pop	eax
					pop	esi
				.else
					pop	esi
				.endif
			.endif
			push	edi
			push	eax
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	eax,'orF '
			stosd
			mov	eax,' :m'
			stosd
			dec	edi
			push	edi
			push	bothnd
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	eax,'<$ '
			stosd
			dec	edi
			push	edi
			push	userID
			call	NickFromId
			.while byte ptr[edi]
				inc	edi
			.endw
			mov	ax,' >'
			stosw
			mov	edx,lpBuf
			.while (byte ptr[edx]!='|')&&(word ptr[edx]!=' >')
				inc	edx
			.endw
			.if word ptr[edx]==' >'
				inc	edx
				inc	edx
			.endif
			xor	ecx,ecx
			.while ecx<32000
				mov	al,[edx]
				stosb
				inc	edx
				.break .if al=='|'
			.endw
			mov	ecx,edi
			sub	ecx,hMem
			push	ecx
			push	hMem
			push	dword ptr[esi-4]
			call	SendTo
		.endif
_nlang:		dec	mstrs
	.endw
	invoke	GlobalFree,hMem
	ret
onPM	ENDP

End DllEntry
